'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MessageComposer = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _debounce3 = require('lodash/debounce');

var _debounce4 = _interopRequireDefault(_debounce3);

var _desc, _value, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRedux = require('react-redux');

var _redux = require('redux');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _coreDecorators = require('core-decorators');

var _reactMentions = require('react-mentions');

var _reduxModuleActivity = require('@ciscospark/redux-module-activity');

var _reduxModuleSearch = require('@ciscospark/redux-module-search');

var _reactContainerPresenceAvatar = require('@ciscospark/react-container-presence-avatar');

var _reactContainerPresenceAvatar2 = _interopRequireDefault(_reactContainerPresenceAvatar);

var _reactContainerFileUploader = require('@ciscospark/react-container-file-uploader');

var _reactContainerFileUploader2 = _interopRequireDefault(_reactContainerFileUploader);

var _actions = require('./actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

var styles = {
  'messageComposer': 'messageComposer--TwXLs',
  'hasFocus': 'hasFocus--idbd2',
  'addFileContainer': 'addFileContainer--3nVF7',
  'textarea': 'textarea--2l5EU',
  'textareaContainerBig': 'textareaContainerBig--3SMEc'
}; // @related-file ./styles.css

var mentionStyles = {
  'mentions': 'mentions--2BWzJ',
  'mentions__control': 'mentions__control--2l6GS',
  'mentions__input': 'mentions__input--307_s',
  'mentions--singleLine': 'mentions--singleLine--bJL-y',
  'mentions__higlighter': 'mentions__higlighter--RxtNY',
  'mentions--multiLine': 'mentions--multiLine--3lraX',
  'mentions__highlighter': 'mentions__highlighter--2Fg8-',
  'mentions__suggestions': 'mentions__suggestions--2axdk',
  'mentions__suggestions__list': 'mentions__suggestions__list--6vEz6',
  'mentions__suggestions__item': 'mentions__suggestions__item--KdkNq',
  'content': 'content--CdpPd',
  'avatar': 'avatar--24BHf',
  'highlighted-display': 'highlighted-display--1FFGD',
  'mentions__suggestions__item--focused': 'mentions__suggestions__item--focused--2JrXz',
  'mentions__mention': 'mentions__mention--3YDNh'
}; // @related-file ./mentions.css

var injectedPropTypes = {
  activity: _propTypes2.default.object.isRequired,
  avatar: _propTypes2.default.object.isRequired,
  conversation: _propTypes2.default.object.isRequired,
  sparkInstance: _propTypes2.default.object.isRequired,
  users: _propTypes2.default.object.isRequired,
  currentUser: _propTypes2.default.object.isRequired,
  messageComposer: _propTypes2.default.object.isRequired,
  blurTextArea: _propTypes2.default.func.isRequired,
  focusTextArea: _propTypes2.default.func.isRequired,
  setUserTyping: _propTypes2.default.func.isRequired,
  submitActivity: _propTypes2.default.func.isRequired,
  searchForUser: _propTypes2.default.func.isRequired,
  storeActivityText: _propTypes2.default.func.isRequired
};

var propTypes = (0, _extends3.default)({
  onSubmit: _propTypes2.default.func.isRequired,
  placeholder: _propTypes2.default.string,
  showMentions: _propTypes2.default.bool
}, injectedPropTypes);

var defaultProps = {
  placeholder: '',
  showMentions: false
};

var MessageComposer = exports.MessageComposer = (_class = function (_Component) {
  (0, _inherits3.default)(MessageComposer, _Component);

  function MessageComposer(props) {
    (0, _classCallCheck3.default)(this, MessageComposer);

    var _this = (0, _possibleConstructorReturn3.default)(this, (MessageComposer.__proto__ || Object.getPrototypeOf(MessageComposer)).call(this, props));

    _this.timerId = 0;
    _this.setUserStartTyping = (0, _debounce4.default)(_this.setUserStartTyping, 500, { leading: true, trailing: false });
    return _this;
  }

  (0, _createClass3.default)(MessageComposer, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      var props = this.props;

      return props.activity !== nextProps.activity || props.placeholder !== nextProps.placeholder;
    }
  }, {
    key: 'setUserTyping',
    value: function setUserTyping(state) {
      var props = this.props;
      var conversation = props.conversation,
          sparkInstance = props.sparkInstance;

      props.setUserTyping(state, conversation, sparkInstance);
    }
  }, {
    key: 'setUserStopTyping',
    value: function setUserStopTyping() {
      this.setUserTyping(false);
    }
  }, {
    key: 'setUserStartTyping',
    value: function setUserStartTyping() {
      this.setUserTyping(true);
    }
  }, {
    key: 'handleTextChange',
    value: function handleTextChange(e, newValue, newValuePlainText) {
      var props = this.props;
      var value = e.target.value;

      if (newValue && newValue.length) {
        value = newValue;
      }
      props.storeActivityText(value, newValuePlainText);

      clearTimeout(this.timerId);
      if (value === '') {
        this.setUserTyping(false);
      } else {
        if (!props.activity.getIn(['status', 'isTyping'])) {
          this.setUserStartTyping();
        }
        this.timerId = setTimeout(this.setUserStopTyping, 3000);
      }
    }
  }, {
    key: 'handleKeyDown',
    value: function handleKeyDown(e) {
      if (e.keyCode === 13 && !e.shiftKey && !e.altKey && !e.ctrlKey && !e.metaKey) {
        this.handleSubmit();
        e.preventDefault();
      }
    }
  }, {
    key: 'handleSubmit',
    value: function handleSubmit() {
      var props = this.props;
      var activity = props.activity,
          conversation = props.conversation,
          sparkInstance = props.sparkInstance,
          currentUser = props.currentUser,
          onSubmit = props.onSubmit;


      if (activity.get('text').length === 0 && activity.get('files').size === 0) {
        return;
      }
      this.setUserTyping(false);
      props.submitActivity(conversation, activity, currentUser, sparkInstance);

      if (typeof onSubmit === 'function') {
        onSubmit();
      }
    }
  }, {
    key: 'handleTextAreaBlur',
    value: function handleTextAreaBlur() {
      var props = this.props;
      var conversation = props.conversation,
          sparkInstance = props.sparkInstance;

      props.blurTextArea();
      props.setUserTyping(false, conversation, sparkInstance);
    }
  }, {
    key: 'handleTextAreaFocus',
    value: function handleTextAreaFocus() {
      this.props.focusTextArea();
    }
  }, {
    key: 'searchForMention',
    value: function searchForMention(term) {
      var _props = this.props,
          avatar = _props.avatar,
          conversation = _props.conversation,
          currentUser = _props.currentUser;

      var participants = [];
      if (conversation.has('participants') && conversation.get('participants').count()) {
        conversation.get('participants').toJS().forEach(function (p) {
          if (currentUser.id !== p.id) {
            participants.push({
              display: p.displayName,
              id: p.id,
              avatarUrl: avatar.getIn(['items', p.id])
            });
          }
        });

        if (term) {
          return participants.filter(function (p) {
            return p.display.toLowerCase().includes(term.toLowerCase());
          });
        }
      }
      return participants;
    }
  }, {
    key: 'render',
    value: function render() {
      var text = void 0;
      var props = this.props;
      var _props2 = this.props,
          activity = _props2.activity,
          messageComposer = _props2.messageComposer,
          placeholder = _props2.placeholder,
          conversation = _props2.conversation;


      if (activity && activity.has('text')) {
        text = activity.get('text');
      }

      var textAreaFocusStyle = messageComposer.getIn(['status', 'hasTextAreaFocus']) ? styles.hasFocus : '';
      var mentionMarkup = '@{__display__}|__id__|';

      // Only show mentions if this is not a one on one convo
      var showMentions = props.showMentions && !conversation.getIn(['status', 'isOneOnOne']);
      var getData = showMentions ? this.searchForMention : function () {};
      return _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)('ciscospark-message-composer', styles.messageComposer, textAreaFocusStyle) },
        _react2.default.createElement(_reactContainerFileUploader2.default, { onSubmit: this.handleSubmit }),
        _react2.default.createElement(
          'div',
          { className: (0, _classnames2.default)('ciscospark-textarea-container') },
          _react2.default.createElement(
            _reactMentions.MentionsInput,
            {
              classNames: mentionStyles,
              markup: mentionMarkup,
              onBlur: this.handleTextAreaBlur,
              onChange: this.handleTextChange,
              onFocus: this.handleTextAreaFocus,
              onKeyDown: this.handleKeyDown,
              onSubmit: this.handleSubmit,
              placeholder: placeholder,
              rows: 1,
              value: text
            },
            _react2.default.createElement(_reactMentions.Mention, {
              className: mentionStyles.mentions__mention,
              data: getData,
              renderSuggestion: MessageComposer.renderSuggestion,
              trigger: '@'
            })
          )
        )
      );
    }
  }], [{
    key: 'renderSuggestion',
    value: function renderSuggestion(entry, search, highlightedDisplay) {
      return _react2.default.createElement(
        'div',
        { className: mentionStyles.content },
        _react2.default.createElement(
          'div',
          { className: mentionStyles.avatar },
          _react2.default.createElement(_reactContainerPresenceAvatar2.default, { avatarId: entry.id, name: entry.display })
        ),
        _react2.default.createElement(
          'div',
          { className: mentionStyles.highlightedDisplay },
          highlightedDisplay
        )
      );
    }
  }]);
  return MessageComposer;
}(_react.Component), (_applyDecoratedDescriptor(_class.prototype, 'setUserTyping', [_coreDecorators.autobind], Object.getOwnPropertyDescriptor(_class.prototype, 'setUserTyping'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'setUserStopTyping', [_coreDecorators.autobind], Object.getOwnPropertyDescriptor(_class.prototype, 'setUserStopTyping'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'handleTextChange', [_coreDecorators.autobind], Object.getOwnPropertyDescriptor(_class.prototype, 'handleTextChange'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'handleKeyDown', [_coreDecorators.autobind], Object.getOwnPropertyDescriptor(_class.prototype, 'handleKeyDown'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'handleSubmit', [_coreDecorators.autobind], Object.getOwnPropertyDescriptor(_class.prototype, 'handleSubmit'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'handleTextAreaBlur', [_coreDecorators.autobind], Object.getOwnPropertyDescriptor(_class.prototype, 'handleTextAreaBlur'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'handleTextAreaFocus', [_coreDecorators.autobind], Object.getOwnPropertyDescriptor(_class.prototype, 'handleTextAreaFocus'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'searchForMention', [_coreDecorators.autobind], Object.getOwnPropertyDescriptor(_class.prototype, 'searchForMention'), _class.prototype)), _class);


MessageComposer.propTypes = propTypes;
MessageComposer.defaultProps = defaultProps;

function mapStateToProps(state, ownProps) {
  return {
    activity: state.activity,
    avatar: state.avatar,
    conversation: state.conversation,
    sparkInstance: ownProps.sparkInstance || state.spark.get('spark'),
    users: state.users,
    messageComposer: state.messageComposer,
    currentUser: state.users.getIn(['byId', state.users.get('currentUserId')])
  };
}

exports.default = (0, _reactRedux.connect)(mapStateToProps, function (dispatch) {
  return (0, _redux.bindActionCreators)({
    blurTextArea: _actions.blurTextArea,
    focusTextArea: _actions.focusTextArea,
    setUserTyping: _reduxModuleActivity.setUserTyping,
    submitActivity: _reduxModuleActivity.submitActivity,
    searchForUser: _reduxModuleSearch.searchForUser,
    storeActivityText: _reduxModuleActivity.storeActivityText
  }, dispatch);
})(MessageComposer);