'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.initialState = undefined;
exports.default = reducer;

var _immutable = require('immutable');

var _actions = require('./actions');

var initialState = exports.initialState = (0, _immutable.fromJS)({
  status: {
    hasTextAreaFocus: false
  }
});

function reducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
  var action = arguments[1];

  switch (action.type) {
    case _actions.UPDATE_TEXTAREA_FOCUS:
      return state.setIn(['status', 'hasTextAreaFocus'], action.payload.state);
    default:
      return state;
  }
}